package be.iminds.ilabt.jfed.rspec.model.bonfire;

import be.iminds.ilabt.jfed.rspec.parser.ExtraXml;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Lan advertised in bonfire advertisement RSpec
 */
public class Lan {
    private final String componentId;
    private final String componentManagerId;
    private final String componentName;
    private final Boolean exclusive;
    private final List<ExtraXml> extraXmls = new ArrayList<ExtraXml>();

    public Lan(String componentId, String componentManagerId, String componentName, Boolean exclusive, List<ExtraXml> extraXmls) {
        this.componentId = componentId;
        this.componentManagerId = componentManagerId;
        this.componentName = componentName;
        this.exclusive = exclusive;
        this.extraXmls.addAll(extraXmls);
    }

    public String getComponentId() {
        return componentId;
    }

    public String getComponentManagerId() {
        return componentManagerId;
    }

    public String getComponentName() {
        return componentName;
    }

    public Boolean getExclusive() {
        return exclusive;
    }

    public List<ExtraXml> getExtraXmls() {
        return Collections.unmodifiableList(extraXmls);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Lan lan = (Lan) o;

        if (componentId != null ? !componentId.equals(lan.componentId) : lan.componentId != null) return false;
        if (componentManagerId != null ? !componentManagerId.equals(lan.componentManagerId) : lan.componentManagerId != null)
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = componentId != null ? componentId.hashCode() : 0;
        result = 31 * result + (componentManagerId != null ? componentManagerId.hashCode() : 0);
        return result;
    }
}
