package be.iminds.ilabt.jfed.util;

import be.iminds.ilabt.jfed.rspec.model.occi.Nic;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.util.JAXBSource;
import javax.xml.namespace.QName;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * JAXBUtil
 */
public class JAXBUtil {
    public static <T> T cloneJaxbObject(Class<T> clazz, T orig) {
        try {
            // Create the JAXBContext
            JAXBContext jc = JAXBContext.newInstance(clazz);

            // Wrap the Customer object in a JAXBElement and a JAXBSource
            JAXBElement<T> originalJAXBElement =
                    new JAXBElement<T>(new QName("root"),clazz, orig);
            JAXBSource source = new JAXBSource(jc, originalJAXBElement);

            // Treat the JAXBSource as an XML input and unmarshal it
            Unmarshaller unmarshaller = jc.createUnmarshaller();
            JAXBElement<T> copiedJAXBElement = unmarshaller.unmarshal(source, clazz);
            T clone = copiedJAXBElement.getValue();
            return clone;
        } catch (JAXBException e) {
            throw new RuntimeException("Error while using JAXB to make a deep copy", e);
        }
    }

    public static <T> List<T> getOneTypeFromContent(Class<T> clazz, List<Object> content) {
        List<T> res = new ArrayList<T>();
        for (Object c : content) {
            if (clazz.isInstance(c)) {
                res.add((T)c);
            }
        }
        return Collections.unmodifiableList(res);
    }
}
